Index: binaries/data/mods/public/gui/common/functions_utility.js
===================================================================
--- binaries/data/mods/public/gui/common/functions_utility.js	(revision 17021)
+++ binaries/data/mods/public/gui/common/functions_utility.js	(working copy)
@@ -146,10 +146,17 @@
 	return ret;
 }
 
 // ====================================================================
 
+function sameColor(color1, color2)
+{
+    return color1.r === color2.r && color1.g === color2.g && color1.b === color2.b;
+}
+
+// ====================================================================
+
 /**
  * Convert time in milliseconds to [hh:]mm:ss string representation.
  * @param time Time period in milliseconds (integer)
  * @return String representing time period
  */
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.js
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.js	(revision 17021)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.js	(working copy)
@@ -8,10 +8,12 @@
 const g_Ceasefire = prepareForDropdown(g_Settings ? g_Settings.Ceasefire : undefined);
 const g_GameSpeeds = prepareForDropdown(g_Settings ? g_Settings.GameSpeeds.filter(speed => !speed.ReplayOnly) : undefined);
 const g_PopulationCapacities = prepareForDropdown(g_Settings ? g_Settings.PopulationCapacities : undefined);
 const g_StartingResources = prepareForDropdown(g_Settings ? g_Settings.StartingResources : undefined);
 
+const g_PlayerColors = initPlayerDefaults().slice(1).map(playerData => playerData.Color);
+
 ////////////////////////////////////////////////////////////////////////////////////////////////
 
 // Is this is a networked game, or offline
 var g_IsNetworked;
 
@@ -378,10 +380,36 @@
 				g_GameAttributes.settings.PlayerData[playerSlot].Team = this.selected - 1;
 
 			updateGameAttributes();
 		};
 
+		// Populate color drop-down lists.
+		var colorPicker = Engine.GetGUIObjectByName("playerColorPicker["+i+"]");
+		colorPicker.list = g_PlayerColors.map(color => '[color="' + color.r + ' ' + color.g + ' ' + color.b + '"]■[/color]' );
+		colorPicker.list_data = g_PlayerColors.map((color, index) => index);
+		colorPicker.selected = -1;
+
+		// Update color
+		colorPicker.onSelectionChange = function()
+		{
+			if (this.selected == -1)
+				return;
+
+			// Add missing properties
+			g_GameAttributes.settings.PlayerData.forEach((pData, index) => {
+				if (!pData.Color)
+					pData.Color = g_PlayerColors[index];
+			});
+
+			// Apply color if noone else has it
+			if (g_GameAttributes.settings.PlayerData.every(pData => !sameColor(g_PlayerColors[this.selected], pData.Color)))
+				g_GameAttributes.settings.PlayerData[playerSlot].Color = g_PlayerColors[this.selected];
+
+			if (!g_IsInGuiUpdate)
+				updateGameAttributes();
+		}
+
 		// Set events
 		var civ = Engine.GetGUIObjectByName("playerCiv["+i+"]");
 		civ.onSelectionChange = function() {
 			if ((this.selected != -1)&&(g_GameAttributes.mapType !== "scenario"))
 				g_GameAttributes.settings.PlayerData[playerSlot].Civ = this.list_data[this.selected];
@@ -1420,10 +1448,11 @@
 		var pCiv = Engine.GetGUIObjectByName("playerCiv["+i+"]");
 		var pCivText = Engine.GetGUIObjectByName("playerCivText["+i+"]");
 		var pTeam = Engine.GetGUIObjectByName("playerTeam["+i+"]");
 		var pTeamText = Engine.GetGUIObjectByName("playerTeamText["+i+"]");
 		var pColor = Engine.GetGUIObjectByName("playerColor["+i+"]");
+		var pColorPicker = Engine.GetGUIObjectByName("playerColorPicker["+i+"]")
 
 		// Player data / defaults
 		var pData = mapSettings.PlayerData ? mapSettings.PlayerData[i] : {};
 		var pDefs = g_DefaultPlayerData ? g_DefaultPlayerData[i] : {};
 
@@ -1447,10 +1476,11 @@
 		// TODO: Allow clients to choose their own civ and team
 		if (!g_IsController || g_GameAttributes.mapType == "scenario")
 		{
 			pCivText.hidden = false;
 			pCiv.hidden = true;
+			pColorPicker.hidden = true;
 			pTeamText.hidden = false;
 			pTeam.hidden = true;
 			// Set text values
 			if (civ == "random")
 				pCivText.caption = "[color=\"orange\"]" + translateWithContext("civilization", "Random");
@@ -1462,13 +1492,15 @@
 		{
 			pCivText.hidden = true;
 			pCiv.hidden = false;
 			pTeamText.hidden = true;
 			pTeam.hidden = false;
+			pColorPicker.hidden = false;
 			// Set dropdown values
 			pCiv.selected = (civ ? pCiv.list_data.indexOf(civ) : 0);
 			pTeam.selected = (team !== undefined && team >= 0) ? team+1 : 0;
+			pColorPicker.selected = g_PlayerColors.findIndex(col => sameColor(col, color));
 		}
 	}
 
 	Engine.GetGUIObjectByName("mapInfoDescription").caption = playerString;
 
Index: binaries/data/mods/public/gui/gamesetup/gamesetup.xml
===================================================================
--- binaries/data/mods/public/gui/gamesetup/gamesetup.xml	(revision 17021)
+++ binaries/data/mods/public/gui/gamesetup/gamesetup.xml	(working copy)
@@ -40,13 +40,16 @@
 			</action>
 
 			<!-- Player assignments -->
 			<object size="24 49 100%-440 345" type="image" sprite="ModernDarkBoxGold" name="playerAssignmentsPanel">
 				<object size="0 6 100% 30">
-					<object name="playerNameHeading" type="text" style="ModernLabelText" size="0 0 22% 100%">
+					<object name="playerNameHeading" type="text" style="ModernLabelText" size="0 0 16% 100%">
 						<translatableAttribute id="caption">Player Name</translatableAttribute>
 					</object>
+					<object name="playerColorHeading" type="text" style="ModernLabelText" size="-3% 0 40% 100%">
+						<translatableAttribute id="caption">Color</translatableAttribute>
+					</object>
 					<object name="playerPlacementHeading" type="text" style="ModernLabelText" size="22%+5 0 50%+35 100%">
 						<translatableAttribute id="caption">Player Placement</translatableAttribute>
 					</object>
 					<object name="playerCivHeading" type="text" style="ModernLabelText" size="50%+65 0 85%-26 100%">
 						<translatableAttribute id="caption">Civilization</translatableAttribute>
@@ -69,11 +72,14 @@
 				</object>
 				<object size="1 36 100%-1 100%">
 					<repeat count="8">
 						<object name="playerBox[n]" size="0 0 100% 32" hidden="true">
 							<object name="playerColor[n]" type="image" size="0 0 100% 100%"/>
-							<object name="playerName[n]" type="text" style="ModernLabelText" size="0 2 22% 30"/>
+							<object name="playerName[n]" type="text" style="ModernLabelText" size="0 0 16% 100%"/>
+							<object name="playerColorPicker[n]" type="dropdown" style="ModernDropDown" size="15%+5 2 20%+5 30" tooltip_style="onscreenToolTip">
+								<translatableAttribute id="tooltip">Pick a color.</translatableAttribute>
+							</object>
 							<object name="playerAssignment[n]" type="dropdown" style="ModernDropDown" size="22%+5 2 50%+35 30" tooltip_style="onscreenToolTip">
 								<translatableAttribute id="tooltip">Select player.</translatableAttribute>
 							</object>
 							<object name="playerAssignmentText[n]" type="text" style="ModernLabelText" size="22%+5 0 50%+35 30"/>
 							<object name="playerConfig[n]" type="button" style="StoneButton" size="50%+40 4 50%+64 28"
